> For the complete documentation index, see [llms.txt](https://docs.yemreak.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.yemreak.com/arsiv/yazilarim/typescript-or-readonly-async-property-tanimlama.md).

# TypeScript | Readonly Async Property Tanımlama

Aşağıda, `readonly` olan ama sonradan asenkron olarak yüklenecek bir özellik nasıl tanımlanabileceğine dair bir TypeScript kodu bulabilirsiniz.

```typescript
class MyClass {
  private _myProp: string | null = null;

  get myProp(): Promise<string> {
    if (this._myProp) {
      return Promise.resolve(this._myProp);
    }
    return this.loadMyProp();
  }

  private async loadMyProp(): Promise<string> {
    // Simulate async operation
    this._myProp = await new Promise((resolve) => setTimeout(() => resolve("Loaded Value"), 1000));
    return this._myProp;
  }
}

// Usage
(async () => {
  const myInstance = new MyClass();
  console.log(await myInstance.myProp);  // Outputs "Loaded Value"
})();
```

* `myProp` aslında bir getter fonksiyonu ve ilk çağrıldığında `_myProp`'u yüklemek için `loadMyProp`'u çağırıyor.
* `_myProp` ilk yüklendikten sonra, herhangi bir yeniden yükleme olmadan aynı değeri kullanacak.
* `myProp` `readonly` olarak kabul edilebilir çünkü dışarıdan değiştirilemez; yalnızca sınıf içerisinden güncellenebilir.

Not: Sınıfın dışından doğrudan `_myProp`'a erişilemediği ve değiştirilemediği için, `myProp` sınıf dışı için `readonly` olarak kabul edilebilir.


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation by asking a question.

Perform an HTTP GET request on the following URL with the `ask` and `goal` query parameters:

```
GET https://docs.yemreak.com/arsiv/yazilarim/typescript-or-readonly-async-property-tanimlama.md?ask=<question>&goal=<user_goal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is what the user is ultimately trying to achieve, the reason they need the answer. Sharing it helps GitBook give you a better, more relevant answer. A goal is most helpful when it describes the outcome the user wants rather than restating the question. For example, with `ask=how do I create an API token`, a goal like `automate deployments from our CI pipeline` lets GitBook tailor the answer to that use case.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
